<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<!--Converted with LaTeX2HTML 2002-2-1 (1.70)
original version by:  Nikos Drakos, CBLU, University of Leeds
* revised and updated by:  Marcus Hennecke, Ross Moore, Herb Swan
* with significant contributions from:
  Jens Lippmann, Marek Rouchal, Martin Wilck and others -->
<HTML>
<HEAD>
<TITLE>User-defined nonlinear equations </TITLE>
<META NAME="description" CONTENT="User-defined nonlinear equations ">
<META NAME="keywords" CONTENT="ccx">
<META NAME="resource-type" CONTENT="document">
<META NAME="distribution" CONTENT="global">

<META NAME="Generator" CONTENT="LaTeX2HTML v2002-2-1">
<META HTTP-EQUIV="Content-Style-Type" CONTENT="text/css">

<LINK REL="STYLESHEET" HREF="ccx.css">

<LINK REL="previous" HREF="node326.html">
<LINK REL="up" HREF="node306.html">
<LINK REL="next" HREF="node328.html">
</HEAD>

<BODY >
<!--Navigation Panel-->
<A NAME="tex2html5113"
  HREF="node328.html">
<IMG WIDTH="37" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="next"
 SRC="file:/usr/share/latex2html/icons/next.png"></A> 
<A NAME="tex2html5109"
  HREF="node306.html">
<IMG WIDTH="26" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="up"
 SRC="file:/usr/share/latex2html/icons/up.png"></A> 
<A NAME="tex2html5105"
  HREF="node326.html">
<IMG WIDTH="63" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="previous"
 SRC="file:/usr/share/latex2html/icons/prev.png"></A> 
<A NAME="tex2html5111"
  HREF="node1.html">
<IMG WIDTH="65" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="contents"
 SRC="file:/usr/share/latex2html/icons/contents.png"></A>  
<BR>
<B> Next:</B> <A NAME="tex2html5114"
  HREF="node328.html">Mean rotation MPC.</A>
<B> Up:</B> <A NAME="tex2html5110"
  HREF="node306.html">User subroutines.</A>
<B> Previous:</B> <A NAME="tex2html5106"
  HREF="node326.html">User-defined thermal material laws.</A>
 &nbsp; <B>  <A NAME="tex2html5112"
  HREF="node1.html">Contents</A></B> 
<BR>
<BR>
<!--End of Navigation Panel-->

<H2><A NAME="SECTION00097000000000000000"></A><A NAME="usermpc"></A>
<BR>
User-defined nonlinear equations 
</H2>

<P>
This user subroutine allows the user to insert his/her own nonlinear
equations (also called Multiple Point Constraints or MPC's). The
driver routine is ``nonlinmpc.f''. For each new type of equation the
user can define a name, e.g. FUN (maximum length 80 characters). To be consistent, the user subroutine should
be called umpc_fun and stored in ``umpc_fun.f''. In file
``nonlinmpc.f'' the lines

<P>
<PRE>
            elseif(labmpc(ii)(1:4).eq.'USER') then
               call umpc_user(aux,aux(3*maxlenmpc+1),const,
     &amp;            aux(6*maxlenmpc+1),iaux,n,fmpc(ii),iit,idiscon)
</PRE>

<P>
should be duplicated and user (USER) replaced by fun (FUN).

<P>
It is assumed that the nonlinear equation is a function of the
displacements only. Then it can generally be written as

<P>
<P></P>
<DIV ALIGN="CENTER"><!-- MATH
 \begin{equation}
f(u_1,u_2,u_3,....,u_n)=0
\end{equation}
 -->
<TABLE CELLPADDING="0" WIDTH="100%" ALIGN="CENTER">
<TR VALIGN="MIDDLE">
<TD NOWRAP ALIGN="CENTER"><IMG
 WIDTH="168" HEIGHT="32" ALIGN="MIDDLE" BORDER="0"
 SRC="img1619.png"
 ALT="$\displaystyle f(u_1,u_2,u_3,....,u_n)=0$"></TD>
<TD NOWRAP WIDTH="10" ALIGN="RIGHT">
(420)</TD></TR>
</TABLE></DIV>
<BR CLEAR="ALL"><P></P>

<P>
where <B><IMG
 WIDTH="19" HEIGHT="30" ALIGN="MIDDLE" BORDER="0"
 SRC="img1620.png"
 ALT="$ u_i$"></B> represents the displacement in node <B><IMG
 WIDTH="19" HEIGHT="30" ALIGN="MIDDLE" BORDER="0"
 SRC="img1621.png"
 ALT="$ n_i$"></B> in direction
<B><IMG
 WIDTH="14" HEIGHT="30" ALIGN="MIDDLE" BORDER="0"
 SRC="img1622.png"
 ALT="$ l_i$"></B>. Nonlinear equations are solved by approximating them
linearly and using an iterative procedure. It is the linearization
which must be provided by the user in the subroutine. Assume we
arrived at an intermediate solution <!-- MATH
 $u^0_1,u^0_2,....u^0_n$
 -->
<B><IMG
 WIDTH="87" HEIGHT="34" ALIGN="MIDDLE" BORDER="0"
 SRC="img1623.png"
 ALT="$ u^0_1,u^0_2,....u^0_n$"></B>. Then the
above equation can be linearly approximated by:

<P>
<P></P>
<DIV ALIGN="CENTER"><!-- MATH
 \begin{equation}
f(u^0_1,u^0_2,....,u^0_n)+\sum_{i=1}^{i=n}\left. \frac{\partial f}{\partial u_i} \right|_0 (u_i-u^0_i)=0
\end{equation}
 -->
<TABLE CELLPADDING="0" WIDTH="100%" ALIGN="CENTER">
<TR VALIGN="MIDDLE">
<TD NOWRAP ALIGN="CENTER"><IMG
 WIDTH="297" HEIGHT="66" ALIGN="MIDDLE" BORDER="0"
 SRC="img1624.png"
 ALT="$\displaystyle f(u^0_1,u^0_2,....,u^0_n)+\sum_{i=1}^{i=n}\left. \frac{\partial f}{\partial u_i} \right\vert _0 (u_i-u^0_i)=0$"></TD>
<TD NOWRAP WIDTH="10" ALIGN="RIGHT">
(421)</TD></TR>
</TABLE></DIV>
<BR CLEAR="ALL"><P></P>

<P>
For more details the user is referred to [<A
 HREF="node378.html#Dhondt">18</A>]. To use a user-defined equation its name must be specified on the line beneath the keyword <A HREF="node261.html#mpc">*MPC</A>, followed by a list of all the
nodes involved in the MPC. This list of nodes is transferred to the
user routine, as specified by the following 
 header and input/output variables of the umpc_user routine:

<P>
<PRE>
      subroutine umpc_user(x,u,f,a,jdof,n,force,iit,idiscon)
!
!     updates the coefficients in a user mpc
!
!     INPUT:
!
!     x(3,n)             Carthesian coordinates of the nodes in the
!                        user mpc.
!     u(3,n)             Actual displacements of the nodes in the
!                        user mpc.     
!     jdof               Actual degrees of freedom of the mpc terms
!     n                  number of terms in the user mpc
!     force              Actual value of the mpc force
!     iit                iteration number
!
!     OUTPUT:
!
!     f                  Actual value of the mpc. If the mpc is
!                        exactly satisfied, this value is zero
!     a(n)               coefficients of the linearized mpc
!     jdof               Corrected degrees of freedom of the mpc terms
!     idiscon            0: no discontinuity
!                        1: discontinuity
!                        If a discontinuity arises the previous
!                        results are not extrapolated at the start of
!                        a new increment
!
</PRE>

<P>
The subroutine returns the value of f (<!-- MATH
 $f(u^0_1,u^0_2,....,u^0_n)$
 -->
<B><IMG
 WIDTH="116" HEIGHT="34" ALIGN="MIDDLE" BORDER="0"
 SRC="img1625.png"
 ALT="$ f(u^0_1,u^0_2,....,u^0_n)$"></B>),
the coefficients of the linearization (<!-- MATH
 $\left. \frac{df}{du_i}
\right|_0$
 -->
<B><IMG
 WIDTH="42" HEIGHT="45" ALIGN="MIDDLE" BORDER="0"
 SRC="img1626.png"
 ALT="$ \left. \frac{df}{du_i}
\right\vert _0$"></B>) and the degrees of freedom involved. 

<P>
The parameter idiscon can be used to specify whether a discontinuity took
place. This usually means that the degrees of freedom in the MPC changed from
the previous call. An example of this is a gap MPC. If a discontinuity
occurred in an increment, the results (displacements..) in this increment are
NOT extrapolated to serve as an initial guess in the next increment.

<P>
An example is given next.

<P>
<BR><HR>
<!--Table of Child-Links-->
<A NAME="CHILD_LINKS"><STRONG>Subsections</STRONG></A>

<UL>
<LI><A NAME="tex2html5115"
  HREF="node328.html">Mean rotation MPC.</A>
<LI><A NAME="tex2html5116"
  HREF="node329.html">Maximum distance MPC.</A>
<LI><A NAME="tex2html5117"
  HREF="node330.html">Gap MPC.</A>
</UL>
<!--End of Table of Child-Links-->
<HR>
<!--Navigation Panel-->
<A NAME="tex2html5113"
  HREF="node328.html">
<IMG WIDTH="37" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="next"
 SRC="file:/usr/share/latex2html/icons/next.png"></A> 
<A NAME="tex2html5109"
  HREF="node306.html">
<IMG WIDTH="26" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="up"
 SRC="file:/usr/share/latex2html/icons/up.png"></A> 
<A NAME="tex2html5105"
  HREF="node326.html">
<IMG WIDTH="63" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="previous"
 SRC="file:/usr/share/latex2html/icons/prev.png"></A> 
<A NAME="tex2html5111"
  HREF="node1.html">
<IMG WIDTH="65" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="contents"
 SRC="file:/usr/share/latex2html/icons/contents.png"></A>  
<BR>
<B> Next:</B> <A NAME="tex2html5114"
  HREF="node328.html">Mean rotation MPC.</A>
<B> Up:</B> <A NAME="tex2html5110"
  HREF="node306.html">User subroutines.</A>
<B> Previous:</B> <A NAME="tex2html5106"
  HREF="node326.html">User-defined thermal material laws.</A>
 &nbsp; <B>  <A NAME="tex2html5112"
  HREF="node1.html">Contents</A></B> 
<!--End of Navigation Panel-->
<ADDRESS>
guido dhondt
2016-07-31
</ADDRESS>
</BODY>
</HTML>
